<template>
	<section class="settings_main w-100">
		<div class="p-3 w-100">
			<div class="base_block p-3 mb-3">
				<form class="dash_ftr" @submit.prevent="getFilteredData">

					<div class="d-flex align-items-center py-2 mr-4">

						<div class="dash_ftr_lbl mr-2">{{ $store.state.locale.category }}:</div>

						<div class="base_select_alt dash_ftr_inp">
							<select class="form-control select_tree" required v-model="selectedCategoryId">
								<option :value="0">Все</option>
								<option v-for="category in categories" :value="category.id">{{category.name}}</option>
							</select>

							<i class="mdi mdi-menu-down"></i>
						</div>
					</div>

					<div class="d-flex align-items-center py-2 mr-4 position-relative">
						<label style="width: 140px;" class="col-form-label">{{$store.state.locale.beginDate}}:</label>
						<datepicker
								v-model="fromDate"
								:config="options">
						</datepicker>
					</div>

					<div class="d-flex align-items-center py-2 mr-4 position-relative">
						<label style="width: 180px;" class="col-form-label">{{$store.state.locale.endDate}}:</label>
						<datepicker
								v-model="toDate"
								:config="options">
						</datepicker>
					</div>


					<button type="submit" class="btn call_save_btn dash_ftr_btn">{{ $store.state.locale.filter }}
					</button>
				</form>
			</div>
			<div class="settings_content_inr base_block">
				<div class="settings_panel p-3">
					<div class="settings_panel_cnt">
						<h3>
							Jami murojaatlar soni: {{allReportsCount}}
						</h3>
						<div v-for="report in reports" v-if="report.tickets.length > 0" class="table-responsive settings_content_tb">
							<h3 class="mt-4 mb-1">
								{{report.districtName}}
							</h3>
							<table class="table table-striped table-hover">
								<thead>
								<tr>
									<th rowspan="3" colspan="1">№</th>
									<th rowspan="1" colspan="8">Murojaat qabul qilish</th>
									<th rowspan="3">Ijro uchun qaysi tashkilotga beriladi</th>
									<th rowspan="1" colspan="3">Bartaraf etilishi</th>
								</tr>

								<tr>
									<th rowspan="2">Murojaat raqami</th>
									<th rowspan="2">Qabul qilingan sana</th>
									<th rowspan="2">Murojatchining F.I.Sh</th>
									<th rowspan="2">Telefon raqami</th>
									<th rowspan="1" colspan="3">Manzili</th>
									<th rowspan="2">Murojaat mazmuni</th>
									<th rowspan="2">Bartaraf etildi</th>
									<th rowspan="2">Sanasi</th>
									<th rowspan="2">Dispetcher F.I.Sh</th>
								</tr>

								<tr>
									<th>Ko'cha nomi</th>
									<th>Uy raqami</th>
									<th>Xonadon raqami</th>
								</tr>
								</thead>
								<tbody>
								<tr v-for="(obj, index) in report.tickets">
									<td>{{index + 1}}</td>
									<td>{{obj.ticketId}}</td>
									<td>{{obj.date | filterDate}}</td>
									<td>{{obj.applicantFullName}}</td>
									<td>{{obj.phoneNumber}}</td>
									<td>{{obj.address.street}}</td>
									<td>{{obj.address.house}}</td>
									<td>{{obj.address.flat}}</td>
									<td>
										<div v-html="obj.ticketDescription"></div>
									</td>
									<td>{{obj.executor}}</td>
									<td>{{obj.isFinished ? 1 : 0}}</td>
									<td>{{obj.finishedDate | filterDate}}</td>
									<td>{{obj.operator1}}</td>
								</tr>
								</tbody>
							</table>

						</div>
					</div>
				</div>
			</div>

		</div>
	</section>
</template>

<script>
	import Datepicker from "vue-bootstrap-datetimepicker";
	import 'pc-bootstrap4-datetimepicker/build/css/bootstrap-datetimepicker.css';

	export default {
		components: {Datepicker},
		data() {
			return {
				reports: [],
				categories: [],
				selectedCategoryId: 0,
				fromDate: '',
				toDate: '',
				options: {
					format: 'YYYY-MM-DD',
					useCurrent: false,
					showClear: true,
					showClose: true,
					locale: 'ru',
					icons: {
						time: 'mdi mdi-clock-outline',
						date: 'mdi mdi-calendar',
						up: 'mdi mdi-arrow-up',
						down: 'mdi mdi-arrow-down',
						previous: 'mdi mdi-arrow-left',
						next: 'mdi mdi-arrow-right',
						today: 'mdi mdi-calendar-today',
						clear: 'mdi mdi-delete-outline',
						close: 'mdi mdi-alpha-x-circle-outline'
					}
				}
			}
		},
		created() {
			this.getAllCategories();
		},
		methods: {
			getAllCategories() {
				axios.get('Admin/category')
					.then(response => {
						this.categories = response.data.data;
						this.selectedCategoryId = response.data.data[0].id;
						this.fromDate = new Date();
						this.toDate = new Date();
						this.getFilteredData();
					})
					.catch(error => {
						console.log(error.message);
					});
			},
			getFilteredData() {
				axios.get('Dashboard/ReportByCategory', {
					params: {
						categoryId: this.selectedCategoryId,
						fromDate: moment(this.fromDate).format('YYYY-MM-DD'),
						toDate: moment(this.toDate).format('YYYY-MM-DD'),
					}
				})
					.then(response => {
						this.reports = response.data.category.tickets
					})
					.catch(error => {
						console.log(error.message)
					});
			}
		},
		filters: {
			filterDate(val) {
				return moment(val).format('DD-MM-YYYY');
			}
		},
		computed: {
			allReportsCount() {
				if (this.reports.length > 0) {
					let allCount = 0;
					this.reports.forEach(x => {
						allCount += x.tickets.length
					})
					return allCount;
				} else {
					return 0;
				}
			}
		}
	}

</script>

<style scoped>
	tr th {
		text-align: center;
		vertical-align: middle;
	}
</style>